/*
 *	main.c
 *
 *	VvGCgA^bN
 *
 *	* Fri Aug  8 00:10:00 JST 2003 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

/****************************************************************************
 *	L`
 ****************************************************************************/

const CHR chr_tbl[] = {
	{ 0x80, 2, 3, 0, 0 },	/* wi */
	{ 0x82, 2, 3, 0, 0 },	/* Vbg */
	{ 0x84, 2, 3, 0, 0 },	/* Vbg */
	{ 0x86, 2, 3, 0, 0 },	/* Vbg */
	{ 0xb0, 2, 3, 0, 0 },	/* Go[@@@ */
	{ 0xb2, 2, 3, 0, 0 },	/* Go[@@ */
	{ 0xb4, 2, 3, 0, 0 },	/* Go[@@ */
	{ 0xb6, 2, 3, 0, 0 },	/* Go[㒆@ */
	{ 0xb8, 2, 3, 0, 0 },	/* Go[@@ */
	{ 0xba, 2, 3, 0, 0 },	/* Go[@ */
	{ 0xbc, 2, 3, 0, 0 },	/* Go[@ */
	{ 0xbe, 2, 3, 0, 0 },	/* Go[㒆 */
};
#define CHR_COUNT	(sizeof chr_tbl / sizeof *chr_tbl)

#define CHR_BACK	(0      )
#define CHR_SHOT(n)	(1 + (n))
#define CHR_ENEMY(n)	(4 + (n))

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		30			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define TRG_0		TRG_SELECT	/* Vbg */
#define TRG_1		TRG_B		/* Vbg */
#define TRG_2		TRG_A		/* Vbg */

#define FIELD_COLS	8	/* tB[h */

typedef struct _GI {
	int score;		/* XRA */
	double speed;		/* G̈ړx (_) */

	int e_dir;		/* G̈ړ (0:E/1:) */

	int enemy;		/* G (0`7Bo[ bit0:/bit1:/bit2: ̑gݍ킹) */
	int e_spd;		/* G̈ړx (24.8bit) */
	int e_pos;		/* G̈ʒu (24.8bit) */

	int shot;		/* Vbg (0:/1:/2:/3:) */
	int s_spd;		/* Vbgړx (24.8bit) */
	int s_pos;		/* Vbgʒu (24.8bit) */

	int field[FIELD_COLS];	/* tB[h (ʕ\p) */
} GI;

#define SPEED_MIN	(1.00 / SEC(1))
#define SPEED_MAX	(1.00)
#define SPEED_RATIO	(1.05)

/****************************************************************************
 *	ʃCAEg
 ****************************************************************************/

#define W_COLUMN	(8 * 2)
#define H_LINE		(8 * 3)

#define X_FIELD		0
#define Y_FIELD		((DISP_Y - H_LINE) / 2)
#define W_FIELD		(W_COLUMN * FIELD_COLS)
#define H_FIELD		H_LINE

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;		/* WbCuŒ`ĂȂ̂ */

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int hiscore;
GI gi;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void field_disp_init();
void field_disp();

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	//int retval;
	//
	///* hFǂݍ݂܂B */
	//thread_lock();
	//retval = loadInst();
	//thread_unlock();
	//if(retval != 0) {
	//	grcls(3);
	//	symbol(4, 34, "drum.binǂݍݎsł", 0, 0);
	//	symbol(4, 44, "h͍Đ܂", 0, 0);
	//	wait(3000);
	//	grcls(-1);
	//}

	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 1,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */

	/* V[hB */
	srand(pceTimerGetCount());
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

		/* PAUSEB */
		if(joy & TRG_START) {
			pause = !pause; /* PAUSEԐ؂ւ */
			if(!pause) pausedisp(0);
		}
		if(!pause) break;

		/* PAUSEbZ[W_ŕ\B */
		if(msec() % 1000 < 750) {
			pausedisp(1);
		} else {
			pausedisp(0);
		}
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, i;

	field_disp_init();
	symbol((DISP_X - 4 * 20) / 2, 16, "[A]:START/[SEL]:EXIT", 2, 0);

	result = 0;
	for(;;) {
		schedule();
		if(joy & TRG_A) {
			result = 0;
			break;
		}
		if(joy & TRG_SELECT) {
			result = -1;
			break;
		}
		for(i = 0; i <= FIELD_COLS - 1; i++) {
			switch((now / SEC(0.25) + i) % 4) {
			case 0:  gi.field[i] = CHR_SHOT(0); break;
			case 1:  gi.field[i] = CHR_SHOT(1); break;
			case 2:  gi.field[i] = CHR_SHOT(2); break;
			default: gi.field[i] = CHR_SHOT(1); break;
			}
		}
		field_disp();
	}

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

static void
game_init()
{
	memset(&gi, 0, sizeof gi);
	gi.speed = SPEED_MIN;
	gi.e_pos = ((FIELD_COLS - 1) / 2) << 8;
	gi.s_spd = 1 << 8; /* Œ */
}

void
game()
{
	int i, gameover;

	sound(2);
	game_init();
	field_disp_init();

	gameover = 0; /* 1:/2:N */
	for(;;) {
		gi.enemy = rnd(7); /* 0`6 */
		gi.e_spd = (int)(gi.speed * (1 << 8));

		for(;;) {
			schedule();
			memset(gi.field, 0, sizeof gi.field);

			/* GړB */
			if(!gi.e_dir) {
				gi.e_pos += gi.e_spd;
				if(gi.e_pos >> 8 >= FIELD_COLS - 1) {
					gi.e_pos = (FIELD_COLS - 1) << 8;
				}
			} else {
				gi.e_pos -= gi.e_spd;
				if(gi.e_pos >> 8 <= 0) {
					gi.e_pos = 0 << 8;
				}
			}

			/* VbgړB */
			if(gi.shot) {
				if(!gi.e_dir) {
					gi.s_pos -= gi.s_spd;
					if(gi.s_pos >> 8 <= 0) {
						gi.s_pos = 0 << 8;
					}
				} else {
					gi.s_pos += gi.s_spd;
					if(gi.s_pos >> 8 >= FIELD_COLS - 1) {
						gi.s_pos = (FIELD_COLS - 1) << 8;
					}
				}
			}

			/* VbgˁB */
			if(joy & (TRG_0 | TRG_1 | TRG_2)) {
L_SHOT:
				if(gi.shot) goto L_HITTEST; /* [VLZAe */
				if(joy & TRG_0) {
					gi.shot = 1;
				} else if(joy & TRG_1) {
					gi.shot = 2;
				} else {
					gi.shot = 3;
				}
				if(!gi.e_dir) {
					gi.s_pos = (FIELD_COLS - 1) << 8 | 0xff;
				} else {
					gi.s_pos = 0 << 8;
				}
				sound(3);
			}

			/* 蔻B */
			if(gi.shot) {
				if(!gi.e_dir) {
					if((gi.e_pos >> 8) >= (gi.s_pos >> 8)) {
						goto L_HITTEST;
					}
				} else {
					if((gi.e_pos >> 8) <= (gi.s_pos >> 8)) {
						goto L_HITTEST;
					}
				}
				goto L_HITTEST_EXIT;
L_HITTEST:
				/* ˔B */
				if(gi.enemy & (1 << (gi.shot - 1))) {
					gameover = 1;
					goto L_GAMEOVER;
				}

				/* Go[jB */
				gi.enemy |= 1 << (gi.shot - 1);
				gi.shot = 0;
				gi.score += 10; /* j|Cg */
				if(gi.score > hiscore) hiscore = gi.score;

				/* SjH */
				if(gi.enemy == 7) {
					sound(0);
					gi.score += 100; /* Sj|Cg */
					if(gi.score > hiscore) hiscore = gi.score;
					gi.field[gi.e_pos >> 8] = CHR_ENEMY(gi.enemy);
					for(i = 0; i < SEC(0.5); i++) {
						schedule();
						field_disp();
					}
					break;
				} else {
					sound(1);
				}

				/* [VLZ̏ꍇ́AVbg˂֖߂B */
				if(joy & (TRG_0 | TRG_1 | TRG_2)) goto L_SHOT;
			}
L_HITTEST_EXIT:

			/* NB */
			if(!gi.e_dir) {
				if(gi.e_pos >> 8 >= FIELD_COLS - 1) {
					goto L_INVADE;
				}
			} else {
				if(gi.e_pos >> 8 <= 0) {
					goto L_INVADE;
				}
			}
			goto L_INVADE_EXIT;
L_INVADE:
			gameover = 2;
			goto L_GAMEOVER;
L_INVADE_EXIT:

			/* \B */
			gi.field[gi.e_pos >> 8] = CHR_ENEMY(gi.enemy);
			if(gi.shot) {
				gi.field[gi.s_pos >> 8] = CHR_SHOT(gi.shot - 1);
			}
			field_disp();
		}

		/* ]B */
		gi.speed *= SPEED_RATIO;
		gi.e_dir = !gi.e_dir;
		if(!gi.e_dir) {
			gi.e_pos &= ~0xff;
		} else {
			gi.e_pos |=  0xff;
		}
	}

L_GAMEOVER:
	sound(2);
	for(i = 0; ; i++) {
		schedule();
		if(i >= SEC(1)) {
			if(joy & (TRG_0 | TRG_1 | TRG_2)) break;
		}
		switch(gameover) {
		case 1: /*  */
			if(i % SEC(0.5) < SEC(0.3)) {
				gi.field[gi.e_pos >> 8] = CHR_ENEMY(gi.enemy |  (1 << (gi.shot - 1)));
			} else {
				gi.field[gi.e_pos >> 8] = CHR_ENEMY(gi.enemy & ~(1 << (gi.shot - 1)));
			}
			break;
		case 2: /* N */
			if(i % SEC(0.5) < SEC(0.3)) {
				gi.field[gi.e_pos >> 8] = CHR_ENEMY(gi.enemy);
			} else {
				gi.field[gi.e_pos >> 8] = CHR_BACK;
			}
			break;
		default:
			DIE();
		}
		locate(4, 2);
		if(i % SEC(0.5) < SEC(0.3)) {
			printstr("GAMEOVER");
		} else {
			printstr("        ");
		}
		field_disp();
	}

	return;
}

/****************************************************************************
 *	field_disp_init
 ****************************************************************************/

void
field_disp_init()
{
	/* ʏB */
	bgcls();
	spcls(0);
	grcls(3); /* wi */

	/* tB[h𔒂ɁB */
#define MARGIN	2
	fill(0         , Y_FIELD               - MARGIN,
	     DISP_X - 1, Y_FIELD + H_FIELD - 1 + MARGIN, 0);
#undef MARGIN

	/* ^Cg\B */
	symbol((DISP_X - (8 * 7 + 4)) / 2      + 1, 1, "8"     , 1, 2);
	symbol((DISP_X - (8 * 7 + 4)) / 2 + 12 + 1, 1, "Attack", 1, 2);
	symbol((DISP_X - (8 * 7 + 4)) / 2         , 1, "8"     , 1, 1);
	symbol((DISP_X - (8 * 7 + 4)) / 2 + 12    , 1, "Attack", 1, 1);
	symbol((DISP_X - (8 * 7 + 4)) / 2      - 1, 1, "8"     , 1, 0);
	symbol((DISP_X - (8 * 7 + 4)) / 2 + 12 - 1, 1, "Attack", 1, 0);
}

/****************************************************************************
 *	field_disp
 ****************************************************************************/

void
field_disp()
{
	int obj, col, chrno, x, y;
	const CHR* chr;

	/* J\B */
	obj = 0;
	x = X_FIELD;
	y = Y_FIELD;
	for(col = 0; col <= FIELD_COLS - 1; col++) {
		chrno = gi.field[col];
		if(chrno < 0 || CHR_COUNT - 1 < chrno) DIE();
		chr = &chr_tbl[chrno];
		obj = chdisp(obj, x, y, chr);
		x += W_COLUMN;
	}
	spcls(obj);

	/* XRA\B */
	locate(4, 8);
	siprintf("HI %05d", hiscore  <= 99999 ? hiscore  : 99999);
	locate(4, 9);
	siprintf("1P %05d", gi.score <= 99999 ? gi.score : 99999);
}
